SystemOrganization addCategory: #'MC2-Extras-VW'!
SystemOrganization addCategory: #'MC2-Extras-PG'!

VW5PackageExporter subclass: #MDVwExporter
	instanceVariableNames: ''
	classVariableNames: 'QualifiedClassNames'
	poolDictionaries: ''
	category: 'MC2-Extras-VW'!

!MDVwExporter class methodsFor: 'intialize-release' stamp: 'cwp 4/9/2005 05:20'!
initialize
	QualifiedClassNames _ Dictionary new.
	QualifiedClassNames
		at: TestCase put: 'XProgramming.SUnit.TestCase';
		at: AbstractString put: 'String';
		at: String put: 'ByteString';
		at: MethodReference put: 'Smalltalk.Store.MethodDescriptor'.! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/20/2005 01:24'!
fileOut
	stream nextPutAll: '<?xml version="1.0"?>'; cr; cr.
	
	self tag: 'st-source' do: [
		self fileOutTimeStamp.
		self fileOutClassDefinitions.
		self fileOutMethods.
		self fileOutInitializers.
	]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 22:26'!
fileOutClassDefinitions
	(ChangeSet superclassOrder: package classes)
		do: [:ea | self fileOutClass: ea]
		displayingProgress: 'Filing out classes...'
		! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:07'!
fileOutClassVariable: aSymbol class: aClass
	self
		fileOutSharedVariable: aSymbol
		environment: (self fullyQualifiedClassNameFor: aClass)
		category: 'class variables'
		package: (self packageNameForClass: aClass)! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 02:58'!
fileOutClass: aClass
	aClass superclass == SharedPool
		ifTrue: [self fileOutSharedPool: aClass]
		ifFalse: [self fileOutClassDefinition: aClass]
! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 22:10'!
fileOutInitializers		
	(package classes select: [:c | c class includesSelector: #initialize])
		do: [:class | self fileOutInitializerForClass: class].! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:25'!
fileOutNameSpace
	self tag: 'name-space' do: [
		self tag: 'name' with: self environment.
		self tag: 'environment' with: 'Smalltalk'.
		self tag: 'private' with: 'false'.
		self tag: 'imports' do: [
			stream nextPutAll: 'private Smalltalk.*'; cr.
			stream nextPutAll: 'private Smalltalk.Squeak.*'; cr.
		].
		self tag: 'category' with: self environment.
		self tag: 'attributes' do: [
			self tag: 'package' with: self environment, '-Core'.
		].
	]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:07'!
fileOutSharedPool: aClass
	self 
		fileOutSharedVariable: aClass name
		environment: self environment
		category: 'shared pools'
		package: (self packageNameForClass: aClass)! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:07'!
fileOutSharedVariable: name environment: namespace category: category package: packageName
	stream cr; cr.
	
	self tag: 'shared-variable' do: [
		self tag: 'name' with: name.
		self tag: 'environment' with: namespace.
		self tag: 'private' with: 'false'.
		self tag: 'constant' with: 'false'.
		self tag: 'category' with: category.
		self tag: 'initializer' with: 'nil'.
		self tag: 'attributes' do: [
			self tag: 'package' with: packageName
		]
	]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 02:19'!
foreignClassNameFor: aClass
	| name |
	name _ QualifiedClassNames at: aClass theNonMetaClass ifAbsent: [^ aClass name].
	^ aClass isMeta
		ifTrue: [name, ' class']
		ifFalse: [name]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 01:26'!
fullyQualifiedClassNameFor: aClass
	^ (package includesClass: aClass)
		ifTrue: [self environment, '.', aClass name]
		ifFalse: [self foreignClassNameFor: aClass]! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 23:12'!
packageNameForClass: aClass
	^ (#('Tests' 'Fakes') anySatisfy: [:ea | aClass theNonMetaClass category endsWith: ea])
		ifFalse: [self environment, '-Core']
		ifTrue: [self environment, '-Tests']! !

!MDVwExporter methodsFor: 'as yet unclassified' stamp: 'cwp 3/19/2005 22:47'!
packageNameForMethod: aMethodReference
	^ self packageNameForClass: aMethodReference actualClass! !

MDRepository subclass: #MDPostgresRepository
	instanceVariableNames: 'connectionArgs connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Extras-PG'!

!MDPostgresRepository class methodsFor: 'as yet unclassified' stamp: 'avi 6/20/2005 13:13'!
connectionArgs: aConnectionArgs
	^ self basicNew initializeWithConnectionArgs: aConnectionArgs! !

!MDPostgresRepository methodsFor: 'private' stamp: 'avi 6/20/2005 13:14'!
close
	connection ifNotNil: [connection terminate]! !

!MDPostgresRepository methodsFor: 'private' stamp: 'cwp 8/21/2005 21:05'!
ensureConnection
	(connection isNil or: [connection isConnected not]) ifTrue:
		[connection _ connectionArgs createConnection.
		connection startup].
	^ connection! !

!MDPostgresRepository methodsFor: 'public' stamp: 'avi 6/20/2005 13:12'!
get: aHashstamp
	| result byteStream |
	result _ self ensureConnection execute: 'SELECT data FROM versions WHERE hashstamp = ', aHashstamp asString printString.
	result rows size = 1 ifFalse: [^ nil].
	byteStream _ Base64MimeConverter mimeDecodeToBytes: result rows first rawData first readStream.
	^ MDMarshal materializeFrom: byteStream! !

!MDPostgresRepository methodsFor: 'private' stamp: 'cwp 8/21/2005 22:23'!
includesHashstamp: aHashstamp
	| result |
	result _ self ensureConnection execute: 'SELECT hashstamp FROM versions WHERE hashstamp = ', aHashstamp asString printString.
	^ result rows size = 1! !

!MDPostgresRepository methodsFor: 'private' stamp: 'avi 6/20/2005 12:55'!
initializeWithConnectionArgs: aConnectionArgs
	connectionArgs _ aConnectionArgs! !

!MDPostgresRepository methodsFor: 'public' stamp: 'avi 6/20/2005 13:22'!
put: aHashedObject
	| key isSnapshot value |
	(self includesHashstamp: aHashedObject hashstamp) ifTrue: [^ self].
	key _ aHashedObject hashstamp asString.
	isSnapshot _ aHashedObject isKindOf: MDSnapshot.
	value _ (Base64MimeConverter mimeEncode: (MDMarshal serialize: aHashedObject) readStream) contents.
	self ensureConnection execute:
		'INSERT INTO versions VALUES (', key printString, ', ', isSnapshot asString, ', ', value printString, ')'! !

!MDPostgresRepository methodsFor: 'private' stamp: 'cwp 8/14/2005 15:15'!
resetConnection
	connection _ nil.
	self ensureConnection! !

!MDPostgresRepository methodsFor: 'public' stamp: 'avi 6/20/2005 13:16'!
snapshotHashstampsDo: aBlock
	| result |
	result _ self ensureConnection execute: 'SELECT hashstamp from versions where is_snapshot = true'.
	result rows do:
		[:ea |
		aBlock value: (MDHashstamp fromString: ea rawData first)]! !

PackageInfo subclass: #MDVwExportInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Extras-VW'!

!MDVwExportInfo class methodsFor: 'exporting' stamp: 'cwp 3/19/2005 00:49'!
export
	self new export! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/20/2005 01:11'!
classes
	^ super classes reject: [:ea | ea category endsWith: '-Info']! !

!MDVwExportInfo methodsFor: 'exporting' stamp: 'cwp 3/19/2005 01:43'!
export
	MDVwExporter fileOutPackage: self! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/19/2005 00:42'!
externalName
	^ 'Monticello'! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 6/18/2005 20:52'!
methodCategoryPrefix
	^ '*monticello2'! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 6/18/2005 20:52'!
methods
	^ super methods! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/19/2005 22:04'!
packageName
	^ 'Monticello2VwExport'! !

!MDVwExportInfo methodsFor: 'registering' stamp: 'cwp 3/19/2005 22:01'!
register
! !

!MDVwExportInfo methodsFor: 'accessing' stamp: 'cwp 3/19/2005 22:06'!
systemCategoryPrefix
	^ 'Monticello2'! !

Object subclass: #MDMockPgConnection
	instanceVariableNames: 'snapshots elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Extras-PG'!

!MDMockPgConnection class methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2005 21:06'!
createConnection
	^ self new! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 23:35'!
execute: aByteString 
	(aByteString beginsWith: 'SELECT hashstamp') 
		ifTrue: [^ self pvtSelectHashstamp: aByteString].
	(aByteString beginsWith: 'SELECT data')
		ifTrue: [^ self pvtSelectData: aByteString].
	(aByteString beginsWith: 'INSERT')
		ifTrue: [^ self pvtInsert: aByteString]! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 22:36'!
isConnected
	^snapshots notNil! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 22:33'!
pvtEmptyResult
	^ (PGResult on: self)
		addResultSet;
		yourself! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 22:58'!
pvtExtractHashstampFrom: aByteString
	^ aByteString 
		copyFrom: aByteString size - 32
		to: aByteString size - 1.! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:20'!
pvtInsert: aByteString 
	| stream hashstamp isSnapshot data |
	stream := aByteString readStream.
	stream skip: 30.
	hashstamp := stream next: 32.
	stream skip: 2.
	isSnapshot := (Boolean readFrom: (stream upTo: $,) readStream).
	stream skip: 2.
	data := stream upTo: $'.
	(isSnapshot
		ifTrue: [snapshots]
		ifFalse: [elements])
			at: hashstamp
			put: data.! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:15'!
pvtResultWith: anArray
	| result row |
	result := PGResult on: self.
	result addResultSet.
	row := PGAsciiRow new.
	row rawData addAll: anArray.
	result rows: (Array with: row).
	^ result
	! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:30'!
pvtSelectData: aByteString 
	| hashstamp |
	hashstamp := self pvtExtractHashstampFrom: aByteString.
	(elements includesKey: hashstamp)
		ifTrue: [^ self pvtResultWith: (Array with: (elements at: hashstamp))].
	(snapshots includesKey: hashstamp)
		ifTrue: [^ self pvtResultWith: (Array with: (snapshots at: hashstamp))].
	^ self pvtEmptyResult! !

!MDMockPgConnection methodsFor: 'private' stamp: 'cwp 8/21/2005 23:35'!
pvtSelectHashstamp: aByteString 
	| hashstamp |
	hashstamp := self pvtExtractHashstampFrom: aByteString.
	^ (hashstamp endsWith: ' tru')
		ifTrue: [self pvtResultWith: (Array with: snapshots keys anyOne)]
		ifFalse: [(snapshots includesKey: hashstamp) 
					ifTrue: [self pvtResultWith: (Array with: hashstamp)]
					ifFalse: [self pvtEmptyResult]]! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 22:57'!
startup
	snapshots := Dictionary new.
	elements := Dictionary new! !

!MDMockPgConnection methodsFor: 'mocking' stamp: 'cwp 8/21/2005 22:57'!
terminate
	snapshots := nil.
	elements := nil! !

MDRepositoryTest subclass: #MDPostgresRepositoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Extras-PG'!

!MDPostgresRepositoryTest methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2005 21:07'!
newRepository
	^ MDPostgresRepository connectionArgs: MDMockPgConnection! !

!MDPostgresRepositoryTest methodsFor: 'as yet unclassified' stamp: 'avi 6/20/2005 13:14'!
tearDown
	repository ensureConnection execute: 'DELETE FROM versions'.
	repository close! !
MDVwExporter initialize!
